#! /usr/bin/perl

use strict;

my @pic = ( );

sub read_pic
{
  my $line;
  my $active = 0;
  while( $line = <> )
  {
    chomp $line;
    chomp $line;
    last if( $active && ($line =~ /^ *$/ || $line =~ /^ *@/) );
    if( $active )
    {
      my @l = split( / +/,  $line );
      $_ = hex( $_ ) foreach( @l );
      push( @pic, [@l,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] )
    }
    $active = 1 if( $line =~ /^ *@/ );
  };
  my $i;
  for( $i = 0; $i < 8; $i++ )
    { push( @pic, [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] ); }
}

sub pix
{
  my $y = shift;
  my $x = shift;
  return @{@pic[$y]}[$x];
}

read_pic;

my ($y, $x, $b);
my @data = ();
for( $y = 0; $y < 8; $y++ ) {
  for( $x = 0; $x < 18; $x++ ) {
    for( $b = 0; $b < 3; $b++ ) {
      my $v = @{@pic[$y]}[$x] & 0x20 << $b;
      my ($bit, $byte);
      if( $x < 16 ) {
        $bit = $x / 2;
        $byte = ($y + ($x % 2) * 8) * 3 + $b;
      } else {
        $bit = $y;
        $byte = $x * 3 + $b;
      }
      @data[$byte] |= 0x01 << $bit if( $v );
    }
  }
}

my $byte;
for( $byte = 0; $byte < 3*18; $byte++ ) {
  printf( "        .db     " ) if( $byte % 6 == 0 );
  printf( "0x%02X", @data[$byte] );
  printf( ", " ) if( $byte % 6 != 5 );
  print "\n" if( $byte % 6 == 5 );
}
